# SIS Frontened Utilities

## About This Package

### What is this package?

This package is a collection of generic functions for converting, mutating, formatting, and validating data.

## Sections

Note: This package has only been tested with typescript. if you're using javascript, use at your own risk

-   [Convert](#convert)
-   [Mutate](#mutate)
-   [Format](#format)
-   [Guard](#guard)

---

## Extract

### SumOfProperty

Coming soon to a codebase near you

---

## Mutate

    Functions that edit a passed element without doing any type conversions

### ConcatenateKeys

#### Params

-   An object of type T, (ex: {firstName: "John", lastName: "Doe", result:""})
-   An array of keys of T to read from. (ex: ["firstName","lastName"] to have "John Doe")
-   A key of T to store the result in. (ex: "result" to return the following object: {firstName: "John", lastName: "Doe", result:"John Doe"})
-   An optional string to separate your concatenated values by. (ex: " - " to see "John - Doe" instead of "John Doe")

    ```
    import {Mutate} from "@scheels-softdev/frontend-utility-functions"
    Mutate.ConcatenateKeys({firstName: "John", lastName: "Doe", result:"" }, ["lastName","firstName"], "result", " - ")
    // returns the following object: {firstName: "John", lastName: "Doe", result:"Doe - John"}
    ```

---

## Format

Functions to change the given input, returning a predetermined type in a predetermined format

### PhoneNumber

#### Params

-   Takes in a string or number, assuming that this has already been validated to ensure it's in a valid format

    ```
    import {Format} from "@scheels-softdev/frontend-utility-functions"
    Format.PhoneNumber(1234567890)
    Format.PhoneNumber("1234567890")
    Format.PhoneNumber("123.456.7890")
    Format.PhoneNumber("123,456,7890")
    Format.PhoneNumber("(123)4567890")
    Format.PhoneNumber("123-456-7890")
    Format.PhoneNumber("(123)456-7890")
    // all return the following string: "(123)456-7890"
    ```

---

### Currency

Coming soon to a codebase near you

## Guard

### Ensure

#### InRange

Coming soon to a codebase near you

#### ValidNumber

Coming soon to a codebase near you

### Catch

#### inRange

Coming soon to a codebase near you

#### NullEmptyOrWhitespace

-   Takes in any single parameter, and returns true if the passed parameter is null, empty, whitespace, or falsey in another way

```

```

#### invalidPhoneNumberFormat

Coming soon to a codebase near you

#### invalidZipCodeFormat

Coming soon to a codebase near you

#### invalidEmailFormat

Coming soon to a codebase near you

#### invalidSkuFormat

Coming soon to a codebase near you
